# Objects

## Add a MobiusFlow object

> The first available instance will be used

```json
{"openapi":"3.1.3","info":{"title":"MobiusFlow® Engine API","version":"3.0.0"},"paths":{"/api/engine/v3/object/{hid}/{sid}/{pid}":{"post":{"summary":"Add a MobiusFlow object","tags":["Objects"],"description":"The first available instance will be used","requestBody":{"content":{"application/json":{"schema":{"description":"The object to add to the service","type":"object","properties":{"configIsDirty":{"type":"boolean"},"rids":{"type":"array","items":{"type":"object","properties":{"rid":{"description":"Resource ID (RID)","type":"string","pattern":"\\b(?:[0-9A-F]{4}|[0-9A-F]{2})\\b"},"settings":{"description":"Resource settings as key value pairs","type":"object","additionalProperties":{}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"]}}},"required":["rid"]}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"]}}},"required":["rids"]}}},"description":"The object to add to the service","required":true},"parameters":[{"schema":{"description":"Hub ID (HID)","type":"string","minLength":6,"maxLength":6,"pattern":"\\b^[0-9A-F]{6}$\\b"},"in":"path","name":"hid","required":true,"description":"Hub ID (HID)"},{"schema":{"description":"Service ID (SID)","type":"string","minLength":3,"maxLength":3,"pattern":"\\b[0-9A-F]{3}$\\b"},"in":"path","name":"sid","required":true,"description":"Service ID (SID)"},{"schema":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"pid","required":true,"description":"Object Profile ID (PID)"}],"responses":{"201":{"description":"Default Response","content":{"application/json":{"schema":{"type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"uri":{"description":"URI of the response","type":"string"},"data":{"type":"object","properties":{"name":{"description":"Service name","type":"string"},"enabled":{"description":"Is the service enabled?","type":"boolean"},"runAtStart":{"description":"Should the service run at start?","type":"boolean"},"config":{"description":"Service configuration","type":"object","properties":{"sid":{"description":"Service ID (SID)","type":"string","minLength":3,"maxLength":3,"pattern":"\\b[0-9A-F]{3}$\\b"},"spid":{"description":"Service Profile ID (SPID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"settings":{"type":"object","properties":{"timeouts":{"type":"object","properties":{"local":{"type":"number"},"remote":{"type":"number"}},"required":["local","remote"],"additionalProperties":false},"persistence":{"type":"object","properties":{"enabled":{"type":"boolean"},"interval":{"type":"number","minimum":1}},"required":["enabled","interval"],"additionalProperties":false},"logging":{"type":"object","properties":{"spoke":{"type":"object","properties":{"level":{"description":"Log level","type":"string","enum":["trace","debug","info","warn","error","fatal"]}},"required":["level"],"additionalProperties":false},"service":{"type":"object","properties":{"level":{"description":"Log level","type":"string","enum":["trace","debug","info","warn","error","fatal"]}},"required":["level"],"additionalProperties":false}},"required":["spoke","service"],"additionalProperties":false}},"required":["timeouts","persistence","logging"],"additionalProperties":false},"custom":{"type":"object","additionalProperties":{}},"objects":{"type":"array","items":{"type":"object","properties":{"pid":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"ins":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"configIsDirty":{"type":"boolean"},"rids":{"type":"array","items":{"type":"object","properties":{"rid":{"description":"Resource ID (RID)","type":"string","pattern":"\\b(?:[0-9A-F]{4}|[0-9A-F]{2})\\b"},"settings":{"description":"Resource settings as key value pairs","type":"object","additionalProperties":{}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["rid"],"additionalProperties":false}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["pid","ins","rids"],"additionalProperties":false}}},"required":["sid","spid","settings","custom","objects"],"additionalProperties":false}},"required":["name","enabled","runAtStart","config"],"additionalProperties":false}},"required":["ts","uri","data"],"additionalProperties":false}}}},"400":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Bad Request","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"401":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unauthorized","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"403":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Forbidden","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"404":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Not Found","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"408":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Request Timeout","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"409":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Conflict","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"422":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unprocessable Entity","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"500":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Internal Server Error","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}}}}}}}
```

## GET /api/engine/v3/object/{hid}/{sid}/{pid}/{ins}

> Read a MobiusFlow object

```json
{"openapi":"3.1.3","info":{"title":"MobiusFlow® Engine API","version":"3.0.0"},"paths":{"/api/engine/v3/object/{hid}/{sid}/{pid}/{ins}":{"get":{"summary":"Read a MobiusFlow object","tags":["Objects"],"parameters":[{"schema":{"description":"Hub ID (HID)","type":"string","minLength":6,"maxLength":6,"pattern":"\\b^[0-9A-F]{6}$\\b"},"in":"path","name":"hid","required":true,"description":"Hub ID (HID)"},{"schema":{"description":"Service ID (SID)","type":"string","minLength":3,"maxLength":3,"pattern":"\\b[0-9A-F]{3}$\\b"},"in":"path","name":"sid","required":true,"description":"Service ID (SID)"},{"schema":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"pid","required":true,"description":"Object Profile ID (PID)"},{"schema":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"ins","required":true,"description":"Object Instance (INS)"}],"responses":{"200":{"description":"Default Response","content":{"application/json":{"schema":{"type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"uri":{"description":"URI of the response","type":"string"},"data":{"description":"A MobiusFlow object","type":"object","properties":{"pid":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"ins":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"profileName":{"type":"string"},"description":{"type":"string"},"resources":{"type":"array","items":{"description":"A MobiusFlow resource","type":"object","properties":{"rid":{"description":"Resource ID","type":"string"},"type":{"type":"string","enum":["bool","number","string","datetime","timespan","enum","alarm"]},"pv":{"description":"A MobiusFlow resource value","anyOf":[{"type":"boolean"},{"type":"number"},{"type":"string"},{"type":"string","nullable":true,"enum":[null]}]},"prar":{"description":"A MobiusFlow resource priority array. The lower the index, the higher the priority","minItems":16,"maxItems":16,"type":"array","items":{"description":"A MobiusFlow resource value","anyOf":[{"type":"boolean"},{"type":"number"},{"type":"string"},{"type":"string","nullable":true,"enum":[null]}]}},"name":{"type":"string"},"settings":{"description":"Resource settings","type":"object","additionalProperties":{}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["rid","type","pv","prar","name","settings"],"additionalProperties":false}},"isFromConfig":{"description":"Is this object from the configuration or an object created live by the service?","type":"boolean"},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["pid","ins","profileName","description","resources"],"additionalProperties":false}},"required":["ts","uri","data"],"additionalProperties":false}}}},"400":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Bad Request","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"401":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unauthorized","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"403":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Forbidden","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"404":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Not Found","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"408":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Request Timeout","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"409":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Conflict","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"422":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unprocessable Entity","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"500":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Internal Server Error","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}}}}}}}
```

## Add a MobiusFlow object

> If the instance is already in use an error will be returned

```json
{"openapi":"3.1.3","info":{"title":"MobiusFlow® Engine API","version":"3.0.0"},"paths":{"/api/engine/v3/object/{hid}/{sid}/{pid}/{ins}":{"post":{"summary":"Add a MobiusFlow object","tags":["Objects"],"description":"If the instance is already in use an error will be returned","requestBody":{"content":{"application/json":{"schema":{"description":"The object to add to the service","type":"object","properties":{"configIsDirty":{"type":"boolean"},"rids":{"type":"array","items":{"type":"object","properties":{"rid":{"description":"Resource ID (RID)","type":"string","pattern":"\\b(?:[0-9A-F]{4}|[0-9A-F]{2})\\b"},"settings":{"description":"Resource settings as key value pairs","type":"object","additionalProperties":{}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"]}}},"required":["rid"]}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"]}}},"required":["rids"]}}},"description":"The object to add to the service","required":true},"parameters":[{"schema":{"description":"Hub ID (HID)","type":"string","minLength":6,"maxLength":6,"pattern":"\\b^[0-9A-F]{6}$\\b"},"in":"path","name":"hid","required":true,"description":"Hub ID (HID)"},{"schema":{"description":"Service ID (SID)","type":"string","minLength":3,"maxLength":3,"pattern":"\\b[0-9A-F]{3}$\\b"},"in":"path","name":"sid","required":true,"description":"Service ID (SID)"},{"schema":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"pid","required":true,"description":"Object Profile ID (PID)"},{"schema":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"ins","required":true,"description":"Object Instance (INS)"}],"responses":{"201":{"description":"Default Response","content":{"application/json":{"schema":{"type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"uri":{"description":"URI of the response","type":"string"},"data":{"type":"object","properties":{"name":{"description":"Service name","type":"string"},"enabled":{"description":"Is the service enabled?","type":"boolean"},"runAtStart":{"description":"Should the service run at start?","type":"boolean"},"config":{"description":"Service configuration","type":"object","properties":{"sid":{"description":"Service ID (SID)","type":"string","minLength":3,"maxLength":3,"pattern":"\\b[0-9A-F]{3}$\\b"},"spid":{"description":"Service Profile ID (SPID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"settings":{"type":"object","properties":{"timeouts":{"type":"object","properties":{"local":{"type":"number"},"remote":{"type":"number"}},"required":["local","remote"],"additionalProperties":false},"persistence":{"type":"object","properties":{"enabled":{"type":"boolean"},"interval":{"type":"number","minimum":1}},"required":["enabled","interval"],"additionalProperties":false},"logging":{"type":"object","properties":{"spoke":{"type":"object","properties":{"level":{"description":"Log level","type":"string","enum":["trace","debug","info","warn","error","fatal"]}},"required":["level"],"additionalProperties":false},"service":{"type":"object","properties":{"level":{"description":"Log level","type":"string","enum":["trace","debug","info","warn","error","fatal"]}},"required":["level"],"additionalProperties":false}},"required":["spoke","service"],"additionalProperties":false}},"required":["timeouts","persistence","logging"],"additionalProperties":false},"custom":{"type":"object","additionalProperties":{}},"objects":{"type":"array","items":{"type":"object","properties":{"pid":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"ins":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"configIsDirty":{"type":"boolean"},"rids":{"type":"array","items":{"type":"object","properties":{"rid":{"description":"Resource ID (RID)","type":"string","pattern":"\\b(?:[0-9A-F]{4}|[0-9A-F]{2})\\b"},"settings":{"description":"Resource settings as key value pairs","type":"object","additionalProperties":{}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["rid"],"additionalProperties":false}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["pid","ins","rids"],"additionalProperties":false}}},"required":["sid","spid","settings","custom","objects"],"additionalProperties":false}},"required":["name","enabled","runAtStart","config"],"additionalProperties":false}},"required":["ts","uri","data"],"additionalProperties":false}}}},"400":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Bad Request","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"401":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unauthorized","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"403":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Forbidden","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"404":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Not Found","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"408":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Request Timeout","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"409":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Conflict","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"422":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unprocessable Entity","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"500":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Internal Server Error","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}}}}}}}
```

## DELETE /api/engine/v3/object/{hid}/{sid}/{pid}/{ins}

> Delete a MobiusFlow object

```json
{"openapi":"3.1.3","info":{"title":"MobiusFlow® Engine API","version":"3.0.0"},"paths":{"/api/engine/v3/object/{hid}/{sid}/{pid}/{ins}":{"delete":{"summary":"Delete a MobiusFlow object","tags":["Objects"],"parameters":[{"schema":{"description":"Hub ID (HID)","type":"string","minLength":6,"maxLength":6,"pattern":"\\b^[0-9A-F]{6}$\\b"},"in":"path","name":"hid","required":true,"description":"Hub ID (HID)"},{"schema":{"description":"Service ID (SID)","type":"string","minLength":3,"maxLength":3,"pattern":"\\b[0-9A-F]{3}$\\b"},"in":"path","name":"sid","required":true,"description":"Service ID (SID)"},{"schema":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"pid","required":true,"description":"Object Profile ID (PID)"},{"schema":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"ins","required":true,"description":"Object Instance (INS)"}],"responses":{"200":{"description":"Default Response","content":{"application/json":{"schema":{"type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"uri":{"description":"URI of the response","type":"string"},"data":{"type":"object","properties":{"name":{"description":"Service name","type":"string"},"enabled":{"description":"Is the service enabled?","type":"boolean"},"runAtStart":{"description":"Should the service run at start?","type":"boolean"},"config":{"description":"Service configuration","type":"object","properties":{"sid":{"description":"Service ID (SID)","type":"string","minLength":3,"maxLength":3,"pattern":"\\b[0-9A-F]{3}$\\b"},"spid":{"description":"Service Profile ID (SPID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"settings":{"type":"object","properties":{"timeouts":{"type":"object","properties":{"local":{"type":"number"},"remote":{"type":"number"}},"required":["local","remote"],"additionalProperties":false},"persistence":{"type":"object","properties":{"enabled":{"type":"boolean"},"interval":{"type":"number","minimum":1}},"required":["enabled","interval"],"additionalProperties":false},"logging":{"type":"object","properties":{"spoke":{"type":"object","properties":{"level":{"description":"Log level","type":"string","enum":["trace","debug","info","warn","error","fatal"]}},"required":["level"],"additionalProperties":false},"service":{"type":"object","properties":{"level":{"description":"Log level","type":"string","enum":["trace","debug","info","warn","error","fatal"]}},"required":["level"],"additionalProperties":false}},"required":["spoke","service"],"additionalProperties":false}},"required":["timeouts","persistence","logging"],"additionalProperties":false},"custom":{"type":"object","additionalProperties":{}},"objects":{"type":"array","items":{"type":"object","properties":{"pid":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"ins":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"configIsDirty":{"type":"boolean"},"rids":{"type":"array","items":{"type":"object","properties":{"rid":{"description":"Resource ID (RID)","type":"string","pattern":"\\b(?:[0-9A-F]{4}|[0-9A-F]{2})\\b"},"settings":{"description":"Resource settings as key value pairs","type":"object","additionalProperties":{}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["rid"],"additionalProperties":false}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["pid","ins","rids"],"additionalProperties":false}}},"required":["sid","spid","settings","custom","objects"],"additionalProperties":false}},"required":["name","enabled","runAtStart","config"],"additionalProperties":false}},"required":["ts","uri","data"],"additionalProperties":false}}}},"400":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Bad Request","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"401":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unauthorized","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"403":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Forbidden","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"404":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Not Found","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"408":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Request Timeout","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"409":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Conflict","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"422":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unprocessable Entity","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"500":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Internal Server Error","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}}}}}}}
```

## Clone a MobiusFlow object

> Clone an object one or more times.\
> The new object INSs will be sequential (skipping any existing object INSs) from the start INS or 0001 if not provided.<br>

```json
{"openapi":"3.1.3","info":{"title":"MobiusFlow® Engine API","version":"3.0.0"},"paths":{"/api/engine/v3/object/clone/{hid}/{sid}/{pid}/{ins}":{"post":{"summary":"Clone a MobiusFlow object","tags":["Objects"],"description":"Clone an object one or more times.\nThe new object INSs will be sequential (skipping any existing object INSs) from the start INS or 0001 if not provided.\n","requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"copies":{"description":"The number of copies to make","type":"number"},"start":{"description":"The INS of the first clone","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"}},"required":["copies"]}}},"required":true},"parameters":[{"schema":{"description":"Hub ID (HID)","type":"string","minLength":6,"maxLength":6,"pattern":"\\b^[0-9A-F]{6}$\\b"},"in":"path","name":"hid","required":true,"description":"Hub ID (HID)"},{"schema":{"description":"Service ID (SID)","type":"string","minLength":3,"maxLength":3,"pattern":"\\b[0-9A-F]{3}$\\b"},"in":"path","name":"sid","required":true,"description":"Service ID (SID)"},{"schema":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"pid","required":true,"description":"Object Profile ID (PID)"},{"schema":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"ins","required":true,"description":"Object Instance (INS)"}],"responses":{"201":{"description":"Default Response","content":{"application/json":{"schema":{"type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"uri":{"description":"URI of the response","type":"string"},"data":{"type":"object","properties":{"name":{"description":"Service name","type":"string"},"enabled":{"description":"Is the service enabled?","type":"boolean"},"runAtStart":{"description":"Should the service run at start?","type":"boolean"},"config":{"description":"Service configuration","type":"object","properties":{"sid":{"description":"Service ID (SID)","type":"string","minLength":3,"maxLength":3,"pattern":"\\b[0-9A-F]{3}$\\b"},"spid":{"description":"Service Profile ID (SPID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"settings":{"type":"object","properties":{"timeouts":{"type":"object","properties":{"local":{"type":"number"},"remote":{"type":"number"}},"required":["local","remote"],"additionalProperties":false},"persistence":{"type":"object","properties":{"enabled":{"type":"boolean"},"interval":{"type":"number","minimum":1}},"required":["enabled","interval"],"additionalProperties":false},"logging":{"type":"object","properties":{"spoke":{"type":"object","properties":{"level":{"description":"Log level","type":"string","enum":["trace","debug","info","warn","error","fatal"]}},"required":["level"],"additionalProperties":false},"service":{"type":"object","properties":{"level":{"description":"Log level","type":"string","enum":["trace","debug","info","warn","error","fatal"]}},"required":["level"],"additionalProperties":false}},"required":["spoke","service"],"additionalProperties":false}},"required":["timeouts","persistence","logging"],"additionalProperties":false},"custom":{"type":"object","additionalProperties":{}},"objects":{"type":"array","items":{"type":"object","properties":{"pid":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"ins":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"configIsDirty":{"type":"boolean"},"rids":{"type":"array","items":{"type":"object","properties":{"rid":{"description":"Resource ID (RID)","type":"string","pattern":"\\b(?:[0-9A-F]{4}|[0-9A-F]{2})\\b"},"settings":{"description":"Resource settings as key value pairs","type":"object","additionalProperties":{}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["rid"],"additionalProperties":false}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["pid","ins","rids"],"additionalProperties":false}}},"required":["sid","spid","settings","custom","objects"],"additionalProperties":false}},"required":["name","enabled","runAtStart","config"],"additionalProperties":false}},"required":["ts","uri","data"],"additionalProperties":false}}}},"400":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Bad Request","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"401":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unauthorized","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"403":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Forbidden","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"404":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Not Found","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"408":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Request Timeout","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"409":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Conflict","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"422":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unprocessable Entity","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"500":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Internal Server Error","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}}}}}}}
```

## POST /api/engine/v3/object/config/ins/{hid}/{sid}/{pid}/{ins}

> Update a MobiusFlow object's INS

```json
{"openapi":"3.1.3","info":{"title":"MobiusFlow® Engine API","version":"3.0.0"},"paths":{"/api/engine/v3/object/config/ins/{hid}/{sid}/{pid}/{ins}":{"post":{"summary":"Update a MobiusFlow object's INS","tags":["Objects"],"requestBody":{"content":{"application/json":{"schema":{"description":"The new INS","type":"object","properties":{"ins":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"}},"required":["ins"]}}},"description":"The new INS","required":true},"parameters":[{"schema":{"description":"Hub ID (HID)","type":"string","minLength":6,"maxLength":6,"pattern":"\\b^[0-9A-F]{6}$\\b"},"in":"path","name":"hid","required":true,"description":"Hub ID (HID)"},{"schema":{"description":"Service ID (SID)","type":"string","minLength":3,"maxLength":3,"pattern":"\\b[0-9A-F]{3}$\\b"},"in":"path","name":"sid","required":true,"description":"Service ID (SID)"},{"schema":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"pid","required":true,"description":"Object Profile ID (PID)"},{"schema":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"ins","required":true,"description":"Object Instance (INS)"}],"responses":{"200":{"description":"Default Response","content":{"application/json":{"schema":{"type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"uri":{"description":"URI of the response","type":"string"},"data":{"type":"object","properties":{"name":{"description":"Service name","type":"string"},"enabled":{"description":"Is the service enabled?","type":"boolean"},"runAtStart":{"description":"Should the service run at start?","type":"boolean"},"config":{"description":"Service configuration","type":"object","properties":{"sid":{"description":"Service ID (SID)","type":"string","minLength":3,"maxLength":3,"pattern":"\\b[0-9A-F]{3}$\\b"},"spid":{"description":"Service Profile ID (SPID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"settings":{"type":"object","properties":{"timeouts":{"type":"object","properties":{"local":{"type":"number"},"remote":{"type":"number"}},"required":["local","remote"],"additionalProperties":false},"persistence":{"type":"object","properties":{"enabled":{"type":"boolean"},"interval":{"type":"number","minimum":1}},"required":["enabled","interval"],"additionalProperties":false},"logging":{"type":"object","properties":{"spoke":{"type":"object","properties":{"level":{"description":"Log level","type":"string","enum":["trace","debug","info","warn","error","fatal"]}},"required":["level"],"additionalProperties":false},"service":{"type":"object","properties":{"level":{"description":"Log level","type":"string","enum":["trace","debug","info","warn","error","fatal"]}},"required":["level"],"additionalProperties":false}},"required":["spoke","service"],"additionalProperties":false}},"required":["timeouts","persistence","logging"],"additionalProperties":false},"custom":{"type":"object","additionalProperties":{}},"objects":{"type":"array","items":{"type":"object","properties":{"pid":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"ins":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"configIsDirty":{"type":"boolean"},"rids":{"type":"array","items":{"type":"object","properties":{"rid":{"description":"Resource ID (RID)","type":"string","pattern":"\\b(?:[0-9A-F]{4}|[0-9A-F]{2})\\b"},"settings":{"description":"Resource settings as key value pairs","type":"object","additionalProperties":{}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["rid"],"additionalProperties":false}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["pid","ins","rids"],"additionalProperties":false}}},"required":["sid","spid","settings","custom","objects"],"additionalProperties":false}},"required":["name","enabled","runAtStart","config"],"additionalProperties":false}},"required":["ts","uri","data"],"additionalProperties":false}}}},"400":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Bad Request","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"401":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unauthorized","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"403":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Forbidden","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"404":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Not Found","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"408":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Request Timeout","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"409":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Conflict","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"422":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unprocessable Entity","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"500":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Internal Server Error","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}}}}}}}
```

## GET /api/engine/v3/object/config/{hid}/{sid}/{pid}/{ins}

> Get a MobiusFlow objects's configuration

```json
{"openapi":"3.1.3","info":{"title":"MobiusFlow® Engine API","version":"3.0.0"},"paths":{"/api/engine/v3/object/config/{hid}/{sid}/{pid}/{ins}":{"get":{"summary":"Get a MobiusFlow objects's configuration","tags":["Objects"],"parameters":[{"schema":{"description":"Hub ID (HID)","type":"string","minLength":6,"maxLength":6,"pattern":"\\b^[0-9A-F]{6}$\\b"},"in":"path","name":"hid","required":true,"description":"Hub ID (HID)"},{"schema":{"description":"Service ID (SID)","type":"string","minLength":3,"maxLength":3,"pattern":"\\b[0-9A-F]{3}$\\b"},"in":"path","name":"sid","required":true,"description":"Service ID (SID)"},{"schema":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"pid","required":true,"description":"Object Profile ID (PID)"},{"schema":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"ins","required":true,"description":"Object Instance (INS)"}],"responses":{"200":{"description":"Default Response","content":{"application/json":{"schema":{"type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"uri":{"description":"URI of the response","type":"string"},"data":{"type":"object","properties":{"pid":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"ins":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"configIsDirty":{"type":"boolean"},"rids":{"type":"array","items":{"type":"object","properties":{"rid":{"description":"Resource ID (RID)","type":"string","pattern":"\\b(?:[0-9A-F]{4}|[0-9A-F]{2})\\b"},"settings":{"description":"Resource settings as key value pairs","type":"object","additionalProperties":{}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["rid"],"additionalProperties":false}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["pid","ins","rids"],"additionalProperties":false}},"required":["ts","uri","data"],"additionalProperties":false}}}},"400":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Bad Request","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"401":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unauthorized","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"403":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Forbidden","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"404":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Not Found","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"408":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Request Timeout","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"409":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Conflict","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"422":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unprocessable Entity","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"500":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Internal Server Error","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}}}}}}}
```

## PATCH /api/engine/v3/object/config/{hid}/{sid}/{pid}/{ins}

> Update a MobiusFlow object's configuration

```json
{"openapi":"3.1.3","info":{"title":"MobiusFlow® Engine API","version":"3.0.0"},"paths":{"/api/engine/v3/object/config/{hid}/{sid}/{pid}/{ins}":{"patch":{"summary":"Update a MobiusFlow object's configuration","tags":["Objects"],"requestBody":{"content":{"application/json":{"schema":{"description":"The object to add to the service","type":"object","properties":{"configIsDirty":{"type":"boolean"},"rids":{"type":"array","items":{"type":"object","properties":{"rid":{"description":"Resource ID (RID)","type":"string","pattern":"\\b(?:[0-9A-F]{4}|[0-9A-F]{2})\\b"},"settings":{"description":"Resource settings as key value pairs","type":"object","additionalProperties":{}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"]}}},"required":["rid"]}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"]}}},"required":["rids"]}}},"description":"The object to add to the service","required":true},"parameters":[{"schema":{"description":"Hub ID (HID)","type":"string","minLength":6,"maxLength":6,"pattern":"\\b^[0-9A-F]{6}$\\b"},"in":"path","name":"hid","required":true,"description":"Hub ID (HID)"},{"schema":{"description":"Service ID (SID)","type":"string","minLength":3,"maxLength":3,"pattern":"\\b[0-9A-F]{3}$\\b"},"in":"path","name":"sid","required":true,"description":"Service ID (SID)"},{"schema":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"pid","required":true,"description":"Object Profile ID (PID)"},{"schema":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"ins","required":true,"description":"Object Instance (INS)"}],"responses":{"200":{"description":"Default Response","content":{"application/json":{"schema":{"type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"uri":{"description":"URI of the response","type":"string"},"data":{"type":"object","properties":{"pid":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"ins":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"configIsDirty":{"type":"boolean"},"rids":{"type":"array","items":{"type":"object","properties":{"rid":{"description":"Resource ID (RID)","type":"string","pattern":"\\b(?:[0-9A-F]{4}|[0-9A-F]{2})\\b"},"settings":{"description":"Resource settings as key value pairs","type":"object","additionalProperties":{}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["rid"],"additionalProperties":false}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["pid","ins","rids"],"additionalProperties":false}},"required":["ts","uri","data"],"additionalProperties":false}}}},"400":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Bad Request","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"401":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unauthorized","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"403":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Forbidden","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"404":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Not Found","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"408":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Request Timeout","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"409":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Conflict","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"422":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unprocessable Entity","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"500":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Internal Server Error","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}}}}}}}
```

## GET /api/engine/v3/object/resource/{hid}/{sid}/{pid}/{ins}/{rid}

> Read a MobiusFlow object resource

```json
{"openapi":"3.1.3","info":{"title":"MobiusFlow® Engine API","version":"3.0.0"},"paths":{"/api/engine/v3/object/resource/{hid}/{sid}/{pid}/{ins}/{rid}":{"get":{"summary":"Read a MobiusFlow object resource","tags":["Objects"],"parameters":[{"schema":{"description":"Hub ID (HID)","type":"string","minLength":6,"maxLength":6,"pattern":"\\b^[0-9A-F]{6}$\\b"},"in":"path","name":"hid","required":true,"description":"Hub ID (HID)"},{"schema":{"description":"Service ID (SID)","type":"string","minLength":3,"maxLength":3,"pattern":"\\b[0-9A-F]{3}$\\b"},"in":"path","name":"sid","required":true,"description":"Service ID (SID)"},{"schema":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"pid","required":true,"description":"Object Profile ID (PID)"},{"schema":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"ins","required":true,"description":"Object Instance (INS)"},{"schema":{"description":"Resource ID (RID)","type":"string","pattern":"\\b(?:[0-9A-F]{4}|[0-9A-F]{2})\\b"},"in":"path","name":"rid","required":true,"description":"Resource ID (RID)"}],"responses":{"200":{"description":"Default Response","content":{"application/json":{"schema":{"type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"uri":{"description":"URI of the response","type":"string"},"data":{"description":"A MobiusFlow resource","type":"object","properties":{"rid":{"description":"Resource ID","type":"string"},"type":{"type":"string","enum":["bool","number","string","datetime","timespan","enum","alarm"]},"pv":{"description":"A MobiusFlow resource value","anyOf":[{"type":"boolean"},{"type":"number"},{"type":"string"},{"type":"string","nullable":true,"enum":[null]}]},"prar":{"description":"A MobiusFlow resource priority array. The lower the index, the higher the priority","minItems":16,"maxItems":16,"type":"array","items":{"description":"A MobiusFlow resource value","anyOf":[{"type":"boolean"},{"type":"number"},{"type":"string"},{"type":"string","nullable":true,"enum":[null]}]}},"name":{"type":"string"},"settings":{"description":"Resource settings","type":"object","additionalProperties":{}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["rid","type","pv","prar","name","settings"],"additionalProperties":false}},"required":["ts","uri","data"],"additionalProperties":false}}}},"400":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Bad Request","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"401":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unauthorized","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"403":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Forbidden","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"404":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Not Found","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"408":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Request Timeout","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"409":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Conflict","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"422":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unprocessable Entity","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"500":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Internal Server Error","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}}}}}}}
```

## PATCH /api/engine/v3/object/resource/{hid}/{sid}/{pid}/{ins}/{rid}

> Write a value to a MobiusFlow object resource

```json
{"openapi":"3.1.3","info":{"title":"MobiusFlow® Engine API","version":"3.0.0"},"paths":{"/api/engine/v3/object/resource/{hid}/{sid}/{pid}/{ins}/{rid}":{"patch":{"summary":"Write a value to a MobiusFlow object resource","tags":["Objects"],"requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"value":{"description":"The value to write to the resource","anyOf":[{"type":"boolean"},{"type":"number"},{"type":"string"},{"type":"string","nullable":true,"enum":[null]}]},"priority":{"description":"The priority to write to. Defaults to priority 15","type":"integer","minimum":1,"maximum":15}},"required":["value"]}}},"required":true},"parameters":[{"schema":{"description":"Hub ID (HID)","type":"string","minLength":6,"maxLength":6,"pattern":"\\b^[0-9A-F]{6}$\\b"},"in":"path","name":"hid","required":true,"description":"Hub ID (HID)"},{"schema":{"description":"Service ID (SID)","type":"string","minLength":3,"maxLength":3,"pattern":"\\b[0-9A-F]{3}$\\b"},"in":"path","name":"sid","required":true,"description":"Service ID (SID)"},{"schema":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"pid","required":true,"description":"Object Profile ID (PID)"},{"schema":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"ins","required":true,"description":"Object Instance (INS)"},{"schema":{"description":"Resource ID (RID)","type":"string","pattern":"\\b(?:[0-9A-F]{4}|[0-9A-F]{2})\\b"},"in":"path","name":"rid","required":true,"description":"Resource ID (RID)"}],"responses":{"200":{"description":"Default Response","content":{"application/json":{"schema":{"type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"uri":{"description":"URI of the response","type":"string"},"data":{"description":"A MobiusFlow resource","type":"object","properties":{"rid":{"description":"Resource ID","type":"string"},"type":{"type":"string","enum":["bool","number","string","datetime","timespan","enum","alarm"]},"pv":{"description":"A MobiusFlow resource value","anyOf":[{"type":"boolean"},{"type":"number"},{"type":"string"},{"type":"string","nullable":true,"enum":[null]}]},"prar":{"description":"A MobiusFlow resource priority array. The lower the index, the higher the priority","minItems":16,"maxItems":16,"type":"array","items":{"description":"A MobiusFlow resource value","anyOf":[{"type":"boolean"},{"type":"number"},{"type":"string"},{"type":"string","nullable":true,"enum":[null]}]}},"name":{"type":"string"},"settings":{"description":"Resource settings","type":"object","additionalProperties":{}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["rid","type","pv","prar","name","settings"],"additionalProperties":false}},"required":["ts","uri","data"],"additionalProperties":false}}}},"400":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Bad Request","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"401":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unauthorized","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"403":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Forbidden","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"404":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Not Found","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"408":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Request Timeout","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"409":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Conflict","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"422":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unprocessable Entity","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"500":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Internal Server Error","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}}}}}}}
```

## PATCH /api/engine/v3/object/resource/{hid}/{sid}/{pid}/{ins}

> Write values to multiple MobiusFlow object resources at once

```json
{"openapi":"3.1.3","info":{"title":"MobiusFlow® Engine API","version":"3.0.0"},"paths":{"/api/engine/v3/object/resource/{hid}/{sid}/{pid}/{ins}":{"patch":{"summary":"Write values to multiple MobiusFlow object resources at once","tags":["Objects"],"requestBody":{"content":{"application/json":{"schema":{"description":"An array of objects containing the value and priority to write to each resource","type":"object","properties":{"updates":{"type":"array","items":{"type":"object","properties":{"r":{"description":"Resource ID (RID)","type":"string","pattern":"\\b(?:[0-9A-F]{4}|[0-9A-F]{2})\\b"},"p":{"description":"A MobiusFlow resource priority","type":"integer","minimum":1,"maximum":15},"v":{"description":"A MobiusFlow resource value","anyOf":[{"type":"boolean"},{"type":"number"},{"type":"string"},{"type":"string","nullable":true,"enum":[null]}]}},"required":["r","p","v"]}}},"required":["updates"]}}},"description":"An array of objects containing the value and priority to write to each resource","required":true},"parameters":[{"schema":{"description":"Hub ID (HID)","type":"string","minLength":6,"maxLength":6,"pattern":"\\b^[0-9A-F]{6}$\\b"},"in":"path","name":"hid","required":true,"description":"Hub ID (HID)"},{"schema":{"description":"Service ID (SID)","type":"string","minLength":3,"maxLength":3,"pattern":"\\b[0-9A-F]{3}$\\b"},"in":"path","name":"sid","required":true,"description":"Service ID (SID)"},{"schema":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"pid","required":true,"description":"Object Profile ID (PID)"},{"schema":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"ins","required":true,"description":"Object Instance (INS)"}],"responses":{"200":{"description":"Default Response","content":{"application/json":{"schema":{"type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"uri":{"description":"URI of the response","type":"string"},"data":{"description":"A MobiusFlow object","type":"object","properties":{"pid":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"ins":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"profileName":{"type":"string"},"description":{"type":"string"},"resources":{"type":"array","items":{"description":"A MobiusFlow resource","type":"object","properties":{"rid":{"description":"Resource ID","type":"string"},"type":{"type":"string","enum":["bool","number","string","datetime","timespan","enum","alarm"]},"pv":{"description":"A MobiusFlow resource value","anyOf":[{"type":"boolean"},{"type":"number"},{"type":"string"},{"type":"string","nullable":true,"enum":[null]}]},"prar":{"description":"A MobiusFlow resource priority array. The lower the index, the higher the priority","minItems":16,"maxItems":16,"type":"array","items":{"description":"A MobiusFlow resource value","anyOf":[{"type":"boolean"},{"type":"number"},{"type":"string"},{"type":"string","nullable":true,"enum":[null]}]}},"name":{"type":"string"},"settings":{"description":"Resource settings","type":"object","additionalProperties":{}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["rid","type","pv","prar","name","settings"],"additionalProperties":false}},"isFromConfig":{"description":"Is this object from the configuration or an object created live by the service?","type":"boolean"},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["pid","ins","profileName","description","resources"],"additionalProperties":false}},"required":["ts","uri","data"],"additionalProperties":false}}}},"400":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Bad Request","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"401":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unauthorized","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"403":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Forbidden","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"404":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Not Found","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"408":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Request Timeout","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"409":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Conflict","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"422":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unprocessable Entity","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"500":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Internal Server Error","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}}}}}}}
```

## PATCH /api/engine/v3/object/resource/clear/{hid}/{sid}/{pid}/{ins}/{rid}

> Clear the value of a MobiusFlow object resource priority

```json
{"openapi":"3.1.3","info":{"title":"MobiusFlow® Engine API","version":"3.0.0"},"paths":{"/api/engine/v3/object/resource/clear/{hid}/{sid}/{pid}/{ins}/{rid}":{"patch":{"summary":"Clear the value of a MobiusFlow object resource priority","tags":["Objects"],"requestBody":{"content":{"application/json":{"schema":{"type":"object","properties":{"priority":{"description":"The priority to clear","type":"integer","minimum":1,"maximum":15}},"required":["priority"]}}},"required":true},"parameters":[{"schema":{"description":"Hub ID (HID)","type":"string","minLength":6,"maxLength":6,"pattern":"\\b^[0-9A-F]{6}$\\b"},"in":"path","name":"hid","required":true,"description":"Hub ID (HID)"},{"schema":{"description":"Service ID (SID)","type":"string","minLength":3,"maxLength":3,"pattern":"\\b[0-9A-F]{3}$\\b"},"in":"path","name":"sid","required":true,"description":"Service ID (SID)"},{"schema":{"description":"Object Profile ID (PID)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"pid","required":true,"description":"Object Profile ID (PID)"},{"schema":{"description":"Object Instance (INS)","type":"string","minLength":4,"maxLength":4,"pattern":"\\b[0-9A-F]{4}$\\b"},"in":"path","name":"ins","required":true,"description":"Object Instance (INS)"},{"schema":{"description":"Resource ID (RID)","type":"string","pattern":"\\b(?:[0-9A-F]{4}|[0-9A-F]{2})\\b"},"in":"path","name":"rid","required":true,"description":"Resource ID (RID)"}],"responses":{"200":{"description":"Default Response","content":{"application/json":{"schema":{"type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"uri":{"description":"URI of the response","type":"string"},"data":{"description":"A MobiusFlow resource","type":"object","properties":{"rid":{"description":"Resource ID","type":"string"},"type":{"type":"string","enum":["bool","number","string","datetime","timespan","enum","alarm"]},"pv":{"description":"A MobiusFlow resource value","anyOf":[{"type":"boolean"},{"type":"number"},{"type":"string"},{"type":"string","nullable":true,"enum":[null]}]},"prar":{"description":"A MobiusFlow resource priority array. The lower the index, the higher the priority","minItems":16,"maxItems":16,"type":"array","items":{"description":"A MobiusFlow resource value","anyOf":[{"type":"boolean"},{"type":"number"},{"type":"string"},{"type":"string","nullable":true,"enum":[null]}]}},"name":{"type":"string"},"settings":{"description":"Resource settings","type":"object","additionalProperties":{}},"tags":{"description":"Tags as key value pairs","type":"object","additionalProperties":{"type":"object","properties":{"value":{"type":"string"},"from":{"anyOf":[{"type":"string","enum":["profile"]},{"type":"string","enum":["instance"]}]}},"required":["from"],"additionalProperties":false}}},"required":["rid","type","pv","prar","name","settings"],"additionalProperties":false}},"required":["ts","uri","data"],"additionalProperties":false}}}},"400":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Bad Request","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"401":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unauthorized","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"403":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Forbidden","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"404":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Not Found","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"408":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Request Timeout","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"409":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Conflict","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"422":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Unprocessable Entity","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}},"500":{"description":"Default Response","content":{"application/json":{"schema":{"description":"Internal Server Error","type":"object","properties":{"ts":{"description":"Timestamp of the response","type":"string"},"statusCode":{"description":"HTTP status code","type":"number"},"errorCode":{"description":"Error code","type":"string"},"message":{"description":"Error message","type":"string"},"detail":{"description":"Error details (optional)"}},"required":["ts","statusCode","errorCode","message"],"additionalProperties":false}}}}}}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
[...]
